searchNodes=[{"type":"module","title":"Gnat","doc":"The primary interface for interacting with NATS","ref":"Gnat.html"},{"type":"function","title":"Gnat.active_subscriptions/1","doc":"Get the number of active subscriptions","ref":"Gnat.html#active_subscriptions/1"},{"type":"function","title":"Gnat.child_spec/1","doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"Gnat.html#child_spec/1"},{"type":"function","title":"Gnat.ping/1","doc":"Ping the NATS server This correlates to the PING command in the NATS protocol. If the NATS server responds with a PONG message this function will return :ok { :ok , gnat } = Gnat . start_link ( ) :ok = Gnat . ping ( gnat )","ref":"Gnat.html#ping/1"},{"type":"function","title":"Gnat.pub/4","doc":"Publish a message { :ok , gnat } = Gnat . start_link ( ) :ok = Gnat . pub ( gnat , &quot;characters&quot; , &quot;Ron Swanson&quot; ) If you want to provide a reply address to receive a response you can pass it as an option. See request-reply pattern . { :ok , gnat } = Gnat . start_link ( ) :ok = Gnat . pub ( gnat , &quot;characters&quot; , &quot;Star Lord&quot; , reply_to : &quot;me&quot; ) If you want to publish a message with headers you can pass the :headers key in the opts like this. { :ok , gnat } = Gnat . start_link ( ) :ok = Gnat . pub ( gnat , &quot;listen&quot; , &quot;Yo&quot; , headers : [ { &quot;foo&quot; , &quot;bar&quot; } ] ) Headers must be passed as a t:headers() value (a list of tuples). Sending and parsing headers has more overhead than typical nats messages (see the Nats 2.2 release notes for details ), so only use them when they are really valuable.","ref":"Gnat.html#pub/4"},{"type":"function","title":"Gnat.request/4","doc":"Send a request and listen for a response synchronously Following the nats request-reply pattern this function generates a one-time topic to receive replies and then sends a message to the provided topic. Supported options: receive_timeout - An integer number of milliseconds to wait for a response. Defaults to 60_000 headers - A set of headers you want to send with the request (see Gnat.pub/4 ) { :ok , gnat } = Gnat . start_link ( ) case Gnat . request ( gnat , &quot;i_can_haz_cheezburger&quot; , &quot;plZZZZ?!?!?&quot; ) do { :ok , %{ body : delicious_cheezburger } } -&gt; :yum { :error , :timeout } -&gt; :sad_cat end No Responders If you send a request to a topic that has no registered listeners, it is sometimes convenient to find out right away, rather than waiting for a timeout to occur. In order to support this use-case, you can start your Gnat connection with the no_responders: true option and this function will return very quickly with an {:error, :no_responders} value. This behavior also works with request_multi/4","ref":"Gnat.html#request/4"},{"type":"function","title":"Gnat.request_multi/4","doc":"Send a request and listen for multiple responses synchronously This function makes it easy to do a scatter-gather operation where you wait for a limited time and optionally a maximum number of replies. Supported options: receive_timeout - An integer number of milliseconds to wait for responses. Defaults to 60_000 max_messages - An integer number of messages to listen for. Defaults to -1 meaning unlimited headers - A set of headers you want to send with the request (see Gnat.pub/4 ) { :ok , gnat } = Gnat . start_link ( ) { :ok , responses } = Gnat . request_multi ( gnat , &quot;i_can_haz_fries&quot; , &quot;plZZZZZ!?!?&quot; , max_messages : 5 ) Enum . count ( responses ) #=&gt; 5","ref":"Gnat.html#request_multi/4"},{"type":"function","title":"Gnat.server_info/1","doc":"Get information about the NATS server the connection is for","ref":"Gnat.html#server_info/1"},{"type":"function","title":"Gnat.start_link/2","doc":"Starts a connection to a nats broker { :ok , gnat } = Gnat . start_link ( %{ host : &#39;127.0.0.1&#39; , port : 4222 } ) # if the server requires TLS you can start a connection with: { :ok , gnat } = Gnat . start_link ( %{ host : &#39;127.0.0.1&#39; , port : 4222 , tls : true } ) # if the server requires TLS and a client certificate you can start a connection with: { :ok , gnat } = Gnat . start_link ( %{ tls : true , ssl_opts : [ certfile : &quot;client-cert.pem&quot; , keyfile : &quot;client-key.pem&quot; ] } ) # you can customize default &quot;_INBOX.&quot; inbox prefix with: { :ok , gnat } = Gnat . start_link ( %{ host : &#39;127.0.0.1&#39; , port : 4222 , inbox_prefix : &quot;my_prefix._INBOX.&quot; } ) # you can use IPv6 addresses too { :ok , gnat } = Gnat . start_link ( %{ host : &#39;::1&#39; , port : 4222 , tcp_opts : [ :inet6 , :binary ] } ) You can also pass arbitrary SSL or TCP options in the tcp_opts and ssl_opts keys. If you pass custom TCP options please include :binary . Gnat uses binary matching to parse messages. The final opts argument will be passed to the GenServer.start_link call so you can pass things like [name: :gnat_connection] .","ref":"Gnat.html#start_link/2"},{"type":"function","title":"Gnat.stop/1","doc":"Gracefully shuts down a connection { :ok , gnat } = Gnat . start_link ( ) :ok = Gnat . stop ( gnat )","ref":"Gnat.html#stop/1"},{"type":"function","title":"Gnat.sub/4","doc":"Subscribe to a topic Supported options: queue_group: a string that identifies which queue group you want to join By default each subscriber will receive a copy of every message on the topic. When a queue_group is supplied messages will be spread among the subscribers in the same group. (see nats queueing ) The subscribed process will begin receiving messages with a structure of sent_message/0 { :ok , gnat } = Gnat . start_link ( ) { :ok , subscription } = Gnat . sub ( gnat , self ( ) , &quot;topic&quot; ) receive do { :msg , %{ topic : &quot;topic&quot; , body : body } } -&gt; IO . puts &quot;Received: \#{ body } &quot; end","ref":"Gnat.html#sub/4"},{"type":"function","title":"Gnat.unsub/3","doc":"Unsubscribe from a topic Supported options: max_messages - Number of messages to be received before automatically unsubscribed This correlates to the UNSUB command in the nats protocol. By default the unsubscribe is affected immediately, but an optional max_messages value can be provided which will allow max_messages to be received before affecting the unsubscribe. This is especially useful for request/reply patterns. { :ok , gnat } = Gnat . start_link ( ) { :ok , subscription } = Gnat . sub ( gnat , self ( ) , &quot;my_inbox&quot; ) :ok = Gnat . unsub ( gnat , subscription ) # OR :ok = Gnat . unsub ( gnat , subscription , max_messages : 2 )","ref":"Gnat.html#unsub/3"},{"type":"type","title":"Gnat.connection_settings/0","doc":"connection_timeout - limits how long it can take to establish a connection to a server host - The location of the NATS server port - The port the NATS server is listening on ssl_opts - Options for connecting over SSL tcp_opts - Options for connecting over TCP tls - If the server should use a TLS connection inbox_prefix - Prefix to use for the message inbox of this connection no_responders - Enable the no responders behavior (see Gnat.request/4 )","ref":"Gnat.html#t:connection_settings/0"},{"type":"type","title":"Gnat.headers/0","doc":"","ref":"Gnat.html#t:headers/0"},{"type":"type","title":"Gnat.message/0","doc":"A message received from NATS will be delivered to your process in this form. Please note that the :reply_to and :headers keys are optional. They will only be present if the message was received from the NATS server with headers or a reply_to topic gnat - The Gnat connection topic - The topic on which the message arrived body - The raw payload of the message sid - The subscription ID corresponding to this message. You generally won't need to use this value directly. reply_to - A topic supplied for expected replies headers - A set of NATS message headers on the message","ref":"Gnat.html#t:message/0"},{"type":"type","title":"Gnat.sent_message/0","doc":"","ref":"Gnat.html#t:sent_message/0"},{"type":"type","title":"Gnat.server_info/0","doc":"Info Protocol client_id - An optional unsigned integer (64 bits) representing the internal client identifier in the server. This can be used to filter client connections in monitoring, correlate with error logs, etc... client_ip - The IP address the client is connecting from cluster - The name of the cluster if any cluster_dynamic - If the cluster is dynamic connect_urls - An optional list of server urls that a client can connect to. ws_connect_urls - An optional list of server urls that a websocket client can connect to. git_commit - The git commit associated with this NATS version go - The version of golang the NATS server was built with headers - If messages can have headers in them host - The IP address used to start the NATS server, by default this will be 0.0.0.0 and can be configured with -client_advertise host:port jetstream - If the server is using JetStream features max_payload - Maximum payload size, in bytes, that the server will accept from the client port - The port number the NATS server is configured to listen on proto - An integer indicating the protocol version of the server. The server version 1.2.0 sets this to 1 to indicate that it supports the &quot;Echo&quot; feature. server_id - The unique identifier of the NATS server server_name - A name for the server version - The version of the NATS server ldm - If the server supports Lame Duck Mode notifications, and the current server has transitioned to lame duck, ldm will be set to true. auth_required - If this is set, then the client should try to authenticate upon connect. tls_required - If this is set, then the client must perform the TLS/1.2 handshake. Note, this used to be ssl_required and has been updated along with the protocol from SSL to TLS. tls_verify - If this is set, the client must provide a valid certificate during the TLS handshake. tls_available - If the server can use TLS","ref":"Gnat.html#t:server_info/0"},{"type":"type","title":"Gnat.t/0","doc":"","ref":"Gnat.html#t:t/0"},{"type":"module","title":"Gnat.ConnectionSupervisor","doc":"A process that can supervise a named connection for you If you would like to supervise a Gnat connection and have it automatically re-connect in case of failure you can use this module in your supervision tree. It takes a map with the following data: gnat_supervisor_settings = %{ name : :gnat , # (required) the registered named you want to give the Gnat connection backoff_period : 4_000 , # number of milliseconds to wait between consecutive reconnect attempts (default: 2_000) connection_settings : [ %{ host : &#39;10.0.0.100&#39; , port : 4222 } , %{ host : &#39;10.0.0.101&#39; , port : 4222 } , ] } The connection settings can specify all of the same values that you pass to Gnat.start_link/1 . Each time a connection is attempted we will use one of the provided connection settings to open the connection. This is a simplistic way of load balancing your connections across a cluster of nats nodes and allowing failover to other nodes in the cluster if one goes down. To use this in your supervision tree add an entry like this: import Supervisor.Spec worker ( Gnat.ConnectionSupervisor , [ gnat_supervisor_settings , [ name : :my_connection_supervisor ] ] ) The second argument is used as GenServer options so you can give the supervisor a registered name as well if you like. Now in the rest of your code you can call things like: :ok = Gnat . pub ( :gnat , &quot;subject&quot; , &quot;message&quot; ) And it will use your supervised connection. If the connection is down when you call that function (or dies during that function) it will raise an error.","ref":"Gnat.ConnectionSupervisor.html"},{"type":"function","title":"Gnat.ConnectionSupervisor.child_spec/1","doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"Gnat.ConnectionSupervisor.html#child_spec/1"},{"type":"function","title":"Gnat.ConnectionSupervisor.start_link/2","doc":"","ref":"Gnat.ConnectionSupervisor.html#start_link/2"},{"type":"module","title":"Gnat.ConsumerSupervisor","doc":"A process that can supervise consumers for you If you want to subscribe to a few topics and have that subscription last across restarts for you, then this worker can be of help. It also spawns a supervised Task for each message it receives. This way errors in message processing don't crash the consumers, but you will still get SASL reports that you can send to services like honeybadger. To use this just add an entry to your supervision tree like this: consumer_supervisor_settings = %{ connection_name : :name_of_supervised_connection , module : MyApp.Server , # a module that implements the Gnat.Server behaviour subscription_topics : [ %{ topic : &quot;rpc.MyApp.search&quot; , queue_group : &quot;rpc.MyApp.search&quot; } , %{ topic : &quot;rpc.MyApp.create&quot; , queue_group : &quot;rpc.MyApp.create&quot; } , ] , } worker ( Gnat.ConsumerSupervisor , [ consumer_supervisor_settings , [ name : :rpc_consumer ] ] , shutdown : 30_000 ) The second argument is a keyword list that gets used as the GenServer options so you can pass a name that you want to register for the consumer process if you like. The :consuming_function specifies which module and function to call when messages arrive. The function will be called with a single argument which is a Gnat.message/0 just like you get when you call Gnat.sub/4 directly. You can have a single consumer that subscribes to multiple topics or multiple consumers that subscribe to different topics and call different consuming functions. It is recommended that your ConsumerSupervisor s are present later in your supervision tree than your ConnectionSupervisor . That way during a shutdown the ConsumerSupervisor can attempt a graceful shutdown of the consumer before shutting down the connection. If you want this consumer supervisor to host a NATS service, then you can specify a module that implements the Gnat.Services.Server behavior. You'll need to specify the service_definition field in the consumer supervisor settings and conforms to the Gnat.Services.Server.service_configuration type. Here is an example of configuring the consumer supervisor to manage a service: consumer_supervisor_settings = %{ connection_name : :name_of_supervised_connection , module : MyApp.Service , # a module that implements the Gnat.Services.Server behaviour service_definition : %{ name : &quot;exampleservice&quot; , description : &quot;This is an example service&quot; , version : &quot;0.1.0&quot; , endpoints : [ %{ name : &quot;add&quot; , group_name : &quot;calc&quot; , } , %{ name : &quot;sub&quot; , group_name : &quot;calc&quot; } ] } } worker ( Gnat.ConsumerSupervisor , [ consumer_supervisor_settings , [ name : :myservice_consumer ] ] , shutdown : 30_000 ) It's also possible to pass a %{consuming_function: {YourModule, :your_function}} rather than a :module in your settings. In that case no error handling or replying is taking care of for you, microservices cannot be used, and it will be up to your function to take whatever action you want with each message.","ref":"Gnat.ConsumerSupervisor.html"},{"type":"function","title":"Gnat.ConsumerSupervisor.child_spec/1","doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"Gnat.ConsumerSupervisor.html#child_spec/1"},{"type":"function","title":"Gnat.ConsumerSupervisor.start_link/2","doc":"","ref":"Gnat.ConsumerSupervisor.html#start_link/2"},{"type":"behaviour","title":"Gnat.Server","doc":"A behavior for acting as a server for nats messages. You can use this behavior in your own module and then use the Gnat.ConsumerSupervisor to listen for and respond to nats messages. Example defmodule MyApp.RpcServer do use Gnat.Server def request ( %{ body : _body } ) do { :reply , &quot;hi&quot; } end # defining an error handler is optional, the default one will just call Logger.error for you def error ( %{ gnat : gnat , reply_to : reply_to } , _error ) do Gnat . pub ( gnat , reply_to , &quot;Something went wrong and I can&#39;t handle your request&quot; ) end end","ref":"Gnat.Server.html"},{"type":"callback","title":"Gnat.Server.error/2","doc":"Called when an error occured during the request/1 If your request/1 function returned {:error, term} , then the term you returned will be passed as the second argument. If an exception was raised during your request/1 function, then the exception will be passed as the second argument. If your request/1 function returned something other than the supported return types, then its return value will be passed as the second argument.","ref":"Gnat.Server.html#c:error/2"},{"type":"callback","title":"Gnat.Server.request/1","doc":"Called when a message is received from the broker","ref":"Gnat.Server.html#c:request/1"},{"type":"behaviour","title":"Gnat.Services.Server","doc":"A behavior for acting as a NATS service Creating a service with this behavior works almost exactly the same as Gnat.Server , with the bonus that this service keeps track of requests, errors, processing time, and participates in service discovery and monitoring as defined by the NATS service protocol . Example defmodule MyApp.Service do use Gnat.Services.Server # Classic subject matching def request ( %{ body : _body , topic : &quot;myservice.req&quot; } , _ , _ ) do { :reply , &quot;handled request&quot; } end # Can also match on endpoint or group def request ( msg , &quot;add&quot; , &quot;calculator&quot; ) do { :reply , &quot;42&quot; } end # defining an error handler is optional, the default one will just call Logger.error for you def error ( %{ gnat : gnat , reply_to : reply_to } , _error ) do Gnat . pub ( gnat , reply_to , &quot;Something went wrong and I can&#39;t handle your request&quot; ) end end","ref":"Gnat.Services.Server.html"},{"type":"callback","title":"Gnat.Services.Server.error/2","doc":"Called when an error occured during the request/1 . Automatically increments the error count and processing time stats for this service. If your request/1 function returned {:error, term} , then the term you returned will be passed as the second argument. If an exception was raised during your request/1 function, then the exception will be passed as the second argument. If your request/1 function returned something other than the supported return types, then its return value will be passed as the second argument.","ref":"Gnat.Services.Server.html#c:error/2"},{"type":"callback","title":"Gnat.Services.Server.request/3","doc":"Called when a message is received from the broker. The endpoint on which the message arrived is always supplied. If the endpoint is a member of a group, the group name will also be provided. Automatically increments the request time and processing time stats for this service.","ref":"Gnat.Services.Server.html#c:request/3"},{"type":"type","title":"Gnat.Services.Server.endpoint_configuration/0","doc":"Each service configuration must contain at least one endpoint. Endpoints can manually specify their subscription subjects or they can be derived from the endpoint name. subject - A specific subject for this endpoint to listen on. If this is not provided, then the endpoint name will be used. name - The required name of the endpoint group_name - An optional group to which this endpoint belongs queue_group - A queue group for this endpoint's subscription. If not supplied, &quot;q&quot; will be used. metadata - An optional string-&gt;string map containing metadata for this endpoint","ref":"Gnat.Services.Server.html#t:endpoint_configuration/0"},{"type":"type","title":"Gnat.Services.Server.service_configuration/0","doc":"Service configuration is provided as part of the consumer supervisor settings in the service_definition field. You can specify either the subscription_topics field for a reguar server or the service_definition field for a new NATS service. name - The name of the service. Needs to conform to the rules for NATS service names version - A required version number (w/out &quot;v&quot; prefix) conforming to semver rules queue_group - An optional queue group for service subscriptions. If left off, &quot;q&quot; will be used. description - An optional description of the service metadata - An optional string-&gt;string map of service metadata endpoints - A required list of service endpoints. All services must have at least one endpoint","ref":"Gnat.Services.Server.html#t:service_configuration/0"},{"type":"extras","title":"README","doc":"Gnat A nats.io client for Elixir. The goals of the project are resiliency, performance, and ease of use. Hex documentation available here: https://hex.pm/packages/gnat","ref":"readme.html"},{"type":"extras","title":"README - Usage","doc":"{ :ok , gnat } = Gnat . start_link ( %{ host : &#39;127.0.0.1&#39; , port : 4222 } ) # Or if the server requires TLS you can start a connection with: # {:ok, gnat} = Gnat.start_link(%{host: &#39;127.0.0.1&#39;, port: 4222, tls: true}) { :ok , subscription } = Gnat . sub ( gnat , self ( ) , &quot;pawnee.*&quot; ) :ok = Gnat . pub ( gnat , &quot;pawnee.news&quot; , &quot;Leslie Knope recalled from city council (Jammed)&quot; ) receive do { :msg , %{ body : body , topic : &quot;pawnee.news&quot; , reply_to : nil } } -&gt; IO . puts ( body ) end","ref":"readme.html#usage"},{"type":"extras","title":"README - Authentication","doc":"# with user and password { :ok , gnat } = Gnat . start_link ( %{ host : &#39;127.0.0.1&#39; , port : 4222 , username : &quot;joe&quot; , password : &quot;123&quot; , auth_required : true } ) # with token { :ok , gnat } = Gnat . start_link ( %{ host : &#39;127.0.0.1&#39; , port : 4222 , token : &quot;secret&quot; , auth_required : true } ) # with an nkey seed { :ok , gnat } = Gnat . start_link ( %{ host : &#39;127.0.0.1&#39; , port : 4222 , nkey_seed : &quot;SUAM...&quot; , auth_required : true } ) # with decentralized user credentials (JWT) { :ok , gnat } = Gnat . start_link ( %{ host : &#39;127.0.0.1&#39; , port : 4222 , nkey_seed : &quot;SUAM...&quot; , jwt : &quot;eyJ0eX...&quot; , auth_required : true } ) # connect to NGS with JWT { :ok , gnat } = Gnat . start_link ( %{ host : &quot;connect.ngs.global&quot; , tls : true , jwt : &quot;ey...&quot; , nkey_seed : &quot;SUAM...&quot; } )","ref":"readme.html#authentication"},{"type":"extras","title":"README - TLS Connections","doc":"NATS Server is often configured to accept or require TLS connections. In order to connect to these clusters you'll want to pass some extra TLS settings to your Gnat connection. # using a basic TLS connection { :ok , gnat } = Gnat . start_link ( %{ host : &#39;127.0.0.1&#39; , port : 4222 , tls : true } ) # Passing a Client Certificate for verification { :ok , gnat } = Gnat . start_link ( %{ tls : true , ssl_opts : [ certfile : &quot;client-cert.pem&quot; , keyfile : &quot;client-key.pem&quot; ] } )","ref":"readme.html#tls-connections"},{"type":"extras","title":"README - Resiliency","doc":"If you would like to stay connected to a cluster of nats servers, you should consider using Gnat.ConnectionSupervisor . This can be added to your supervision tree in your project and will handle automatically re-connecting to the cluster. For long-lived subscriptions consider using Gnat.ConsumerSupervisor . This can also be added to your supervision tree and use a supervised connection to re-establish a subscription. It also handles details like handling each message in a supervised process so you isolate failures and get OTP logs when an unexpected error occurs.","ref":"readme.html#resiliency"},{"type":"extras","title":"README - Services","doc":"If you supply a module that implements the Gnat.Services.Server behavior and the service_definition configuration field to a Gnat.ConsumerSupervisor , then this client will automatically take care of exposing the service to discovery, responding to pings, and maintaining and exposing statistics like request and error counts, and processing times.","ref":"readme.html#services"},{"type":"extras","title":"README - Instrumentation","doc":"Gnat uses telemetry to make instrumentation data available to clients. If you want to record metrics around the number of messages or latency of message publishes, subscribes, requests, etc you can do the following in your project: iex(1)&gt; metrics_function = fn ( event_name , measurements , event_meta , config ) -&gt; IO . inspect ( [ event_name , measurements , event_meta , config ] ) :ok end # Function &lt; 4.128620087 / 4 in :erl_eval . expr / 5 &gt; iex(2)&gt; names = [ [ :gnat , :pub ] , [ :gnat , :sub ] , [ :gnat , :message_received ] , [ :gnat , :request ] , [ :gnat , :unsub ] ] [ [ :gnat , :pub ] , [ :gnat , :sub ] , [ :gnat , :message_received ] , [ :gnat , :request ] , [ :gnat , :unsub ] , [ :gnat , :service_request ] , [ :gnat , :service_error ] ] iex(3)&gt; :telemetry . attach_many ( &quot;my listener&quot; , names , metrics_function , %{ my_config : true } ) :ok iex(4)&gt; { :ok , gnat } = Gnat . start_link ( ) { :ok , # PID &lt; 0 . 203 . 0 &gt; } iex(5)&gt; Gnat . sub ( gnat , self ( ) , &quot;topic&quot; ) [ [ :gnat , :sub ] , %{ latency : 128000 } , %{ topic : &quot;topic&quot; } , %{ my_config : true } ] { :ok , 1 } iex(6)&gt; Gnat . pub ( gnat , &quot;topic&quot; , &quot;ohai&quot; ) [ [ :gnat , :pub ] , %{ latency : 117000 } , %{ topic : &quot;topic&quot; } , %{ my_config : true } ] [ [ :gnat , :message_received ] , %{ count : 1 } , %{ topic : &quot;topic&quot; } , %{ my_config : true } ] :ok The pub , sub , request , and unsub events all report the latency of those respective calls. The message_received event reports a number of messages like %{count: 1} because there isn't a good latency metric to report. Any microservices managed by a consumer supervisor will also report service_request and service_error . In addition to the :topic metadata, microservices will also include :endpoint and :group (which can be nil ) in their telemetry reports. All of the events (except unsub ) include metadata with a :topic key so you can split your metrics by topic.","ref":"readme.html#instrumentation"},{"type":"extras","title":"README - Benchmarks","doc":"Part of the motivation for building this library is to get better performance. To this end, there is a bench branch on this project which includes a server.exs and client.exs that can be used for benchmarking various scenarios. As of this commit, the latest benchmark on a 16-core server shows that you can make 170k+ req/sec or up to 192MB/sec. The bench/*.exs files also contain some straight-line single-CPU performance tests. As of this commit my 2018 MacBook pro shows. ips average deviation median parse-128 487.67 K 2.19 μs ±1701.54% 2 μs pub - 128 96.37 K 10.38 μs ±102.94% 10 μs req-reply-128 8.32 K 120.16 μs ±23.68% 114 μs","ref":"readme.html#benchmarks"},{"type":"extras","title":"README - Development","doc":"Before running the tests make sure you have a locally running copy of nats-server ( installation instructions ). We currently use version 2.6.6 in CI, but anything higher than 2.2.0 should be fine. Versions from 0.9.6 up to 2.2.0 should work fine for everything except header support. The typical mix test will run all the basic unit tests. You can also run the multi_server set of tests that test connectivity to different nats-server configurations. You can run these with mix test --only multi_server . The tests will tell you how to start the different configurations. There are also some property-based tests that generate a lot of test cases. You can tune how many test cases by setting the environment variable N=200 mix test --only property (default it 100). For more details you can look at how Travis runs these things in the CI flow.","ref":"readme.html#development"},{"type":"extras","title":"Changelog","doc":"","ref":"changelog.html"},{"type":"extras","title":"Changelog - 1.7","doc":"Added support for the NATS services API , letting developers participate in service discovery and stats https://github.com/nats-io/nats.ex/pull/141","ref":"changelog.html#1-7"},{"type":"extras","title":"Changelog - 1.6","doc":"added the no_responders behavior https://github.com/nats-io/nats.ex/pull/137","ref":"changelog.html#1-6"},{"type":"extras","title":"Changelog - 1.5","doc":"add the inbox_prefix option https://github.com/nats-io/nats.ex/pull/121 add the Gnat.server_info/1 function https://github.com/nats-io/nats.ex/pull/124 fix header parsing issue https://github.com/nats-io/nats.ex/pull/125","ref":"changelog.html#1-5"},{"type":"extras","title":"Changelog - 1.4","doc":"add the Gnat.request_multi/4 function https://github.com/nats-io/nats.ex/pull/120 add elixir 1.13 to the test matrix","ref":"changelog.html#1-4"},{"type":"extras","title":"Changelog - 1.3","doc":"adding support for sending and receiving headers https://github.com/nats-io/nats.ex/pull/116","ref":"changelog.html#1-3"},{"type":"extras","title":"Changelog - 1.2","doc":"Gnat.Server behaviour with support in the ConsumerSupervisor https://github.com/nats-io/nats.ex/compare/1b1adc85e4b28231218ef87c7fc3445fce854377...b24a7e14325b51fbb93fde7e3d891d18b4fa8afb avoid logging sensitive credentials https://github.com/nats-io/nats.ex/pull/105 deprecate Gnat.ping, improved typespecs https://github.com/nats-io/nats.ex/pull/103 relax the version constraint on nimble_parsec https://github.com/nats-io/nats.ex/issues/112","ref":"changelog.html#1-2"},{"type":"extras","title":"Changelog - 1.1","doc":"add support for nkeys and NGS https://github.com/nats-io/nats.ex/pull/101 Fix supervisor ConsumerSuperivsor crash https://github.com/nats-io/nats.ex/pull/96","ref":"changelog.html#1-1"},{"type":"extras","title":"Changelog - 1.0","doc":"Make supervisors officially supported https://github.com/nats-io/nats.ex/pull/96","ref":"changelog.html#1-0"},{"type":"extras","title":"Changelog - 0.7.0","doc":"update to telemetry 0.4 https://github.com/nats-io/nats.ex/pull/86 and https://github.com/nats-io/nats.ex/pull/87 support for token authentication https://github.com/nats-io/nats.ex/pull/92 support elixir 1.9 https://github.com/nats-io/nats.ex/pull/93","ref":"changelog.html#0-7-0"},{"type":"extras","title":"Changelog - 0.6.0","doc":"Dropped support for Erlang &lt; 19 and Elixir &lt;= 1.5 Added Telemetry to the project (thanks @rubysolo) Switched to nimble_parsec for parsing Updated benchmarking/performance information. We can now do 170k requests per second on a 16-core server. Fixed a bug around re-subscribing for the ConsumerSupervisor Pass sid when delivering message (thanks @entone) Documentation fixes from @deini and @johannestroeger","ref":"changelog.html#0-6-0"},{"type":"extras","title":"Changelog - 0.5.0","doc":"Dropped support for Elixir 1.4 and OTP 18 releases. You will need to use Elixir 1.5+ and OTP 19+. Switched to running our tests against gnatsd 1.3.0","ref":"changelog.html#0-5-0"}]